import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

/**
 * This world class is not necessary for the actors delays.
 * You just have to coppy the methods started and stopped into your worldclass. Or if you already got this methods you add the code of the methods declared here to your existing methods.
 * 
 * For this methods you have to import java.util.List (see imports abouve). The import if java.awt.Color is not necessary;
 */
public class DelayWorld extends World
{
    
    public DelayWorld() {
        super(800, 400, 1);
        getBackground().setColor(Color.blue);
        getBackground().fill();
        GreenfootImage text = new GreenfootImage("This demo includes a superclass for delaying actors.\nOnly the actors will be paused and not the whole execution like\nin the case you use Greenfoot.delay()." + 
            "You just need to add\nthe superclass DelayableActor and some world methods\nto your scenario and you can use it. Discriptions how\nto use the classes and methods are to be found in the classes." + 
            "\n\nI hope this demo can help you.", 35, Color.red, new Color(0, 0, 0, 0));
        getBackground().drawImage(text, getWidth()/2 - text.getWidth()/2, getHeight()/2 - text.getHeight()/2);
    }
    
    /**
     * Informs all DelayableActor objects if the execution has been started.
     */
    public void started() {
        List<DelayableActor> delayableActors = getObjects(DelayableActor.class);
        for (DelayableActor actor : delayableActors) {
            actor.executionStarted();
        }
    }
    /**
     * Informs all DelayableActor objects if the execution has been stopped.
     */
    public void stopped() {
        List<DelayableActor> delayableActors = getObjects(DelayableActor.class);
        for (DelayableActor actor : delayableActors) {
            actor.executionStopped();
        }
    }
}
